<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.inout.serial &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.inout.serial</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.inout.serial</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to save and open JSON and PICKLE files.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">makedirs</span>
<span class="kn">from</span> <span class="nn">os.path</span> <span class="kn">import</span> <span class="n">dirname</span>
<span class="kn">from</span> <span class="nn">functools</span> <span class="kn">import</span> <span class="n">partial</span>


<div class="viewcode-block" id="try_makedirs"><a class="viewcode-back" href="../../../lib.inout.html#lib.inout.serial.try_makedirs">[docs]</a><span class="k">def</span> <span class="nf">try_makedirs</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Create all the necessary directories of a path</span>

<span class="sd">    Args:</span>
<span class="sd">        path: path</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">makedirs</span><span class="p">(</span><span class="n">path</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">OSError</span><span class="p">:</span>
        <span class="k">pass</span></div>


<span class="k">def</span> <span class="nf">_get_library_from_str</span><span class="p">(</span><span class="n">library_str</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Get the IO module of interest from a string.</span>

<span class="sd">    Args:</span>
<span class="sd">        library_str: ``pickle`` or ``json``</span>

<span class="sd">    Returns:</span>
<span class="sd">        library: corresponding module</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">library_str</span> <span class="o">==</span> <span class="s2">&quot;pickle&quot;</span><span class="p">:</span>
        <span class="kn">import</span> <span class="nn">pickle</span>
        <span class="k">return</span> <span class="n">pickle</span>
    <span class="k">elif</span> <span class="n">library_str</span> <span class="o">==</span> <span class="s2">&quot;json&quot;</span><span class="p">:</span>
        <span class="kn">import</span> <span class="nn">json</span>
        <span class="k">return</span> <span class="n">json</span>


<span class="k">def</span> <span class="nf">_save</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">library</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">byte_write</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Save the data in a file in ``{loc[&#39;out&#39;]}/{type_data}/``</span>

<span class="sd">    Args:</span>
<span class="sd">        data : element to save. if ``library`` is ``&#39;json&#39;``,</span>
<span class="sd">            must be a dictionnary</span>
<span class="sd">        folder_path : path of the folder where the file is located</span>
<span class="sd">        name : name of the file</span>
<span class="sd">        library : ``json`` or ``pickle``, library used to save the file</span>
<span class="sd">        byte_write : write in byte mode</span>
<span class="sd">        kwargs: passed to the save function of the corresponding</span>
<span class="sd">            serial library.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">try_makedirs</span><span class="p">(</span><span class="n">dirname</span><span class="p">(</span><span class="n">path</span><span class="p">))</span>

    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span> <span class="o">+</span> <span class="n">byte_write</span> <span class="o">*</span> <span class="s1">&#39;b&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">_get_library_from_str</span><span class="p">(</span><span class="n">library</span><span class="p">)</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">data</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;{library.title()} file saved in </span><span class="si">{path}</span><span class="s2">&quot;</span><span class="p">)</span>


<span class="n">save_pickle</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">_save</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s1">&#39;pickle&#39;</span><span class="p">,</span> <span class="n">byte_write</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">save_json</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">_save</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s1">&#39;json&#39;</span><span class="p">,</span> <span class="n">sort_keys</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
<span class="n">save_joblib</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">_save</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s1">&#39;joblib&#39;</span><span class="p">,</span> <span class="n">byte_write</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>


<span class="n">save_pickle</span><span class="o">.</span><span class="vm">__doc__</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;Save a pickle file (in byte mode)</span>

<span class="s2">    Args:</span>
<span class="s2">        data : element to save.</span>
<span class="s2">        path : PICKLE file path</span>
<span class="s2">&quot;&quot;&quot;</span>

<span class="n">save_json</span><span class="o">.</span><span class="vm">__doc__</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;save a json file in ``</span><span class="si">{loc[&#39;json&#39;]}</span><span class="s2">/``</span>

<span class="s2">    Args:</span>
<span class="s2">        data : dictionnary to save.</span>
<span class="s2">        path : JSON file path</span>
<span class="s2">&quot;&quot;&quot;</span>


<span class="k">def</span> <span class="nf">_load</span><span class="p">(</span><span class="n">path</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">library</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;json&#39;</span><span class="p">,</span> <span class="n">byte_read</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; load the content of a file.</span>

<span class="sd">    Args:</span>
<span class="sd">        path : path where the file is located</span>
<span class="sd">        library : ``json`` or ``pickle``, library used to save the file</span>
<span class="sd">        byte_read : read in byte mode</span>

<span class="sd">    Returns:</span>
<span class="sd">        element that was saved in ``{folder_path}/{name}.{library}``</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">try_makedirs</span><span class="p">(</span><span class="n">dirname</span><span class="p">(</span><span class="n">path</span><span class="p">))</span>

    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span> <span class="o">+</span> <span class="n">byte_read</span> <span class="o">*</span> <span class="s1">&#39;b&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">data</span> <span class="o">=</span> <span class="n">_get_library_from_str</span><span class="p">(</span><span class="n">library</span><span class="p">)</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Open </span><span class="si">{path}</span><span class="s2">&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">data</span>


<span class="n">load_pickle</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">_load</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s1">&#39;pickle&#39;</span><span class="p">,</span> <span class="n">byte_read</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">load_json</span> <span class="o">=</span> <span class="n">partial</span><span class="p">(</span><span class="n">_load</span><span class="p">,</span> <span class="n">library</span><span class="o">=</span><span class="s1">&#39;json&#39;</span><span class="p">,</span> <span class="n">byte_read</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

<span class="n">load_pickle</span><span class="o">.</span><span class="vm">__doc__</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;Load the content of a pickle file</span>

<span class="s2">    Args:</span>
<span class="s2">        path : PICKLE file path</span>

<span class="s2">    Returns:</span>
<span class="s2">        element that was saved in ``</span><span class="si">{folder_path}</span><span class="s2">/</span><span class="si">{name}</span><span class="s2">.pickle``</span>
<span class="s2">&quot;&quot;&quot;</span>

<span class="n">load_json</span><span class="o">.</span><span class="vm">__doc__</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;Load the content of a json file</span>

<span class="s2">    Args:</span>
<span class="s2">        path : JSON file path</span>

<span class="s2">    Returns:</span>
<span class="s2">        dictionnary that was saved in ``</span><span class="si">{folder_path}</span><span class="s2">/</span><span class="si">{name}</span><span class="s2">.json``</span>
<span class="s2">&quot;&quot;&quot;</span>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>